using System;
namespace B_plazma
{
    internal class Program
    {
        static void Main(string[] args)
        {
            string[] linija1 = Console.ReadLine().Split(' ');
            int n = int.Parse(linija1[0]);
            int q = int.Parse(linija1[1]);

            long[] daniPronadjenePlazme = new long[n];
            int[] kolicinaKupljenePlazme = new int[n];

            for (int i = 0; i < n; i++)
            {
                string[] linija = Console.ReadLine().Split(' ');
                daniPronadjenePlazme[i] = long.Parse(linija[0]);
                kolicinaKupljenePlazme[i] = int.Parse(linija[1]);
            }

            long[] daniPrestankaJedenja = new long[q];

            for (int i = 0; i < q; i++)
            {
                daniPrestankaJedenja[i] = long.Parse(Console.ReadLine());
            }



            long[] odgovori = new long[q];

            long plazmaNaRaspolaganju = 0;
            long pojedenaPlazma = 0;

            for (long dan = (long)Math.Min(daniPrestankaJedenja[0], daniPronadjenePlazme[0]), i = 0, j = 0; 
                dan <= daniPrestankaJedenja[q - 1] && j < q; )
            {
                if (i < n && dan == daniPronadjenePlazme[i])
                {
                    plazmaNaRaspolaganju += kolicinaKupljenePlazme[i];
                    i++;
                }

                if (daniPrestankaJedenja[j] == dan)
                {
                    odgovori[j] = pojedenaPlazma;
                    j++;
                    if (j >= q)
                    {
                        break;
                    }
                }


                long dan2;
                if (i < n)
                {
                    dan2 = (long)Math.Min(daniPrestankaJedenja[j], daniPronadjenePlazme[i]);
                }
                else
                {
                    dan2 = daniPrestankaJedenja[j];
                }
                
                pojedenaPlazma += (long)Math.Min((dan2 - dan + 1), plazmaNaRaspolaganju);
                plazmaNaRaspolaganju -= (long)Math.Min((dan2 - dan + 1), plazmaNaRaspolaganju);
                dan = dan2;

            }

            foreach (long odgovor in odgovori)
            {
                Console.WriteLine(odgovor);
            }
        }
    }
}